package javax.swing.plaf.multi;

import javax.accessibility.Accessible;
import java.awt.Dimension;
import java.awt.Graphics;
import javax.swing.JComponent;
import java.awt.Rectangle;
import javax.swing.tree.TreePath;
import javax.swing.JTree;
import javax.swing.plaf.ComponentUI;
import java.util.Vector;
import javax.swing.plaf.TreeUI;

public class MultiTreeUI extends TreeUI
{
    protected Vector uis;
    
    public MultiTreeUI() {
        this.uis = new Vector();
    }
    
    public ComponentUI[] getUIs() {
        return MultiLookAndFeel.uisToArray(this.uis);
    }
    
    @Override
    public Rectangle getPathBounds(JTree tree, TreePath treePath) {
        Rectangle pathBounds = ((TreeUI)(TreeUI)this.uis.elementAt(0)).getPathBounds(tree, treePath);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((TreeUI)(TreeUI)this.uis.elementAt(i)).getPathBounds(tree, treePath);
        }
        return pathBounds;
    }
    
    @Override
    public TreePath getPathForRow(JTree tree, int n) {
        TreePath pathForRow = ((TreeUI)(TreeUI)this.uis.elementAt(0)).getPathForRow(tree, n);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((TreeUI)(TreeUI)this.uis.elementAt(i)).getPathForRow(tree, n);
        }
        return pathForRow;
    }
    
    @Override
    public int getRowForPath(JTree tree, TreePath treePath) {
        int rowForPath = ((TreeUI)(TreeUI)this.uis.elementAt(0)).getRowForPath(tree, treePath);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((TreeUI)(TreeUI)this.uis.elementAt(i)).getRowForPath(tree, treePath);
        }
        return rowForPath;
    }
    
    @Override
    public int getRowCount(JTree tree) {
        int rowCount = ((TreeUI)(TreeUI)this.uis.elementAt(0)).getRowCount(tree);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((TreeUI)(TreeUI)this.uis.elementAt(i)).getRowCount(tree);
        }
        return rowCount;
    }
    
    @Override
    public TreePath getClosestPathForLocation(JTree tree, int n, int n2) {
        TreePath closestPathForLocation = ((TreeUI)(TreeUI)this.uis.elementAt(0)).getClosestPathForLocation(tree, n, n2);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((TreeUI)(TreeUI)this.uis.elementAt(i)).getClosestPathForLocation(tree, n, n2);
        }
        return closestPathForLocation;
    }
    
    @Override
    public boolean isEditing(JTree tree) {
        int editing = ((TreeUI)(TreeUI)this.uis.elementAt(0)).isEditing(tree);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((TreeUI)(TreeUI)this.uis.elementAt(i)).isEditing(tree);
        }
        return editing;
    }
    
    @Override
    public boolean stopEditing(JTree tree) {
        int stopEditing = ((TreeUI)(TreeUI)this.uis.elementAt(0)).stopEditing(tree);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((TreeUI)(TreeUI)this.uis.elementAt(i)).stopEditing(tree);
        }
        return stopEditing;
    }
    
    @Override
    public void cancelEditing(JTree tree) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((TreeUI)(TreeUI)this.uis.elementAt(i)).cancelEditing(tree);
        }
    }
    
    @Override
    public void startEditingAtPath(JTree tree, TreePath treePath) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((TreeUI)(TreeUI)this.uis.elementAt(i)).startEditingAtPath(tree, treePath);
        }
    }
    
    @Override
    public TreePath getEditingPath(JTree tree) {
        TreePath editingPath = ((TreeUI)(TreeUI)this.uis.elementAt(0)).getEditingPath(tree);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((TreeUI)(TreeUI)this.uis.elementAt(i)).getEditingPath(tree);
        }
        return editingPath;
    }
    
    @Override
    public boolean contains(JComponent component, int n, int n2) {
        int contains = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).contains(component, n, n2);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).contains(component, n, n2);
        }
        return contains;
    }
    
    @Override
    public void update(Graphics g, JComponent c) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).update(g, c);
        }
    }
    
    public static ComponentUI createUI(JComponent component) {
        MultiTreeUI multiTreeUI = new MultiTreeUI();
        return MultiLookAndFeel.createUIs(multiTreeUI, ((MultiTreeUI)multiTreeUI).uis, component);
    }
    
    @Override
    public void installUI(JComponent c) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).installUI(c);
        }
    }
    
    @Override
    public void uninstallUI(JComponent c) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).uninstallUI(c);
        }
    }
    
    @Override
    public void paint(Graphics g, JComponent c) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).paint(g, c);
        }
    }
    
    @Override
    public Dimension getPreferredSize(JComponent component) {
        Dimension preferredSize = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).getPreferredSize(component);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).getPreferredSize(component);
        }
        return preferredSize;
    }
    
    @Override
    public Dimension getMinimumSize(JComponent component) {
        Dimension minimumSize = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).getMinimumSize(component);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).getMinimumSize(component);
        }
        return minimumSize;
    }
    
    @Override
    public Dimension getMaximumSize(JComponent component) {
        Dimension maximumSize = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).getMaximumSize(component);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).getMaximumSize(component);
        }
        return maximumSize;
    }
    
    @Override
    public int getAccessibleChildrenCount(JComponent component) {
        int accessibleChildrenCount = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).getAccessibleChildrenCount(component);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).getAccessibleChildrenCount(component);
        }
        return accessibleChildrenCount;
    }
    
    @Override
    public Accessible getAccessibleChild(JComponent component, int n) {
        Accessible accessibleChild = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).getAccessibleChild(component, n);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).getAccessibleChild(component, n);
        }
        return accessibleChild;
    }
}
